﻿Type=Activity
Version=2.30
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
' The FFT library is based on a port of the FFT from the SciMark2a Java Benchmark To C#
' by Chris Re (cmr28@cornell.edu) AND Werner Vogels (vogels@cs.cornell.edu)
' For details on the original authors see http://math.nist.gov/scimark2

' Library adapted for B4PPC by Andrew Graham
' Program written by Klaus Christl

' The program uses following functions from the FFT.dll
' Fft.Version				in DisplayHelp
' Fft.ToAmplitude		in CalcFFT
' Fft.ToPhase				in CalcFFT

' Fft.Transform			in CalcFFT							with the variable Transform = 0
' Fft.Inverse				in CalcFFTInv						with the variable Transform = 0
' Fft.CopyArray			in CalcFFT/CalcFFTInv		with the variable Transform = 0
' Fft.Transform2		in CalcFFT							with the variable Transform = 2
' Fft.Inverse2			in CalcFFTInv						with the variable Transform = 2

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim AStream As AsyncStreams

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim ProgName As String			: ProgName="FFTdemo"
	Dim ProgVersion As String		: ProgVersion="V 1.0"
	Dim ProgAuthor As String		: ProgAuthor="Klaus CHRISTL"
	Dim ProgDate As String			: ProgDate="dec 2010"

	Dim Transform As Int	
	Dim conv As ByteConverter
Dim SendData() As Byte
Dim pm As PackageManager
    Dim RealData() As Int  
	Dim txtInput As EditText
	Dim txtLog As EditText
	Dim btnSend As Button
	Transform=0		' used with Transform  and Inverse
	Transform=2		' used with Transform2 and Inverse2
	
	Dim FFT As FFT
	Dim lblDisplay,lblTitle1, lblTitle2, lblAbscissa1, lblAbscissa2, lblValue1, lblValue2 As Label
	Dim lsvDisplay As ListView
	Dim cvsImage As Canvas
	Dim rectDest,rectScreen, rectCursor As Rect
	Dim pnlList, pnlDrawDisp1, pnlDrawDisp2, pnlFFTType, pnlDispFunc, pnlCursorTools As Panel
	Dim pnlHelp, pnlCursorTools, pnlFFTInverse, pnlInput, pnlToolBox, pnlDisp, pnlDispTools As Panel
	Dim btnListAmpl, btnListPhase, btnFFTInverse, btnFFTAP, btnFFTRI As Button
	Dim btnListReal, btnListImag, btnListAmpl, btnListPhase, btnHelpOK  As Button
	Dim btnCalcSines1, btnCalcSines3, btnCalcCosines3, btnCalcSinesN, btnNSinesSetup, btnHelp As Button
	Dim btnDispList, btnDispDraw, btnHelpPrev, btnHelpNext, btnHelpLast,btnHelpFirst  As Button
	Dim btnCursorRight, btnCursorLeft, btnDispTime, btnDispFFT, btnFFTDelete, btnInputOK As Button
	Dim btnInput0, btnInput1, btnInput2, btnInput3, btnInput4, btnInput5,btnInputCancel As Button
	Dim btnInput6, btnInput7, btnInput8, btnInput9, btnInputDot, btnInputMinus, btnInputBS As Button
	Dim btnInputClr, btnInputDel, btnInputStart, btnInputEnd, btnInputLeft, btnInputRight  As Button
	''Dim txtSineNbPeriods, txtSineAmpl, txtSinePhase, lblInputTitle, Label1 As Label
	''Dim txtSineOffset, txtSineDamping, txtModulationPercent, txtModulationPeriod As Label
	Dim lblHelp1, lblHelp2, lblHelp3, txtInputDisplay, txtInputDispCurs, SendView,lblInputTitle, Label1 As Label
	''Dim ckbOffset, ckbDamping, ckbSineModulation, ckbRound As CheckBox
	Dim ckbRound As CheckBox
	''Dim spnSineIndex, spnSinesNb As Spinner
	Dim scvHelp As ScrollView
	Dim Timer1 As Timer
	
' definition of button colors
	Dim gd1 As GradientDrawable
	Dim gd2 As GradientDrawable
	Dim colsList1(2) As Int
	Dim colsList2(2) As Int
	Dim sdList1, sdList2 As StateListDrawable
	Dim colsSine1(2) As Int
	Dim colsSine2(2) As Int
	Dim sdSine1, sdSine2 As StateListDrawable
	Dim colsDisp1(2) As Int
	Dim colsDisp2(2) As Int
	Dim sdDisp1, sdDisp2 As StateListDrawable
	Dim colsFFT1(2) As Int
	Dim colsFFT2(2) As Int
	Dim sdFFT1, sdFFT2 As StateListDrawable
	Dim colsTime1(2) As Int
	Dim colsTime2(2) As Int
	Dim sdTime1, sdTime2 As StateListDrawable

	' caluclation variables
	Dim NN As Int								: NN = 256					' total number of data samples
	Dim NM1 As Int							: NM1=NN-1					' total number of data samples -1
	Dim ND2 As Int							: ND2=NN/2					' half number of data samples
	Dim ND2_1 As Int						: ND2_1=ND2-1				' half number of data samples -1
	Dim RadDeg As Double				: RadDeg=180/cPI

' time data
	Dim DataReal(NN) As Double		' real time data
	Dim DataImag(NN) As Double		' imaginary time data
	Dim DataRealMax As Double			' max real time value		 used to increase graphic speed
	Dim DataRealMean As Double		'	mean real time value
	Dim DataRealMin As Double			' min real time value
	Dim DataImagMax As Double			' max imaginary time value
	Dim DataImagMean As Double		' mean imaginary time value
	Dim DataImagMin As Double			' min imaginary time value

' FFT data
	Dim FFTReal(0) As Double			' real 			 FFT data
	Dim FFTImag(0) As Double			' imaginary  FFT data
	Dim FFTAmpl(0) As Double			' amplitude  FFT data
	Dim FFTPhase(0) As Double			' phase 		 FFT data
	Dim FFTRealMax As Double			' max  real	 FFT value		 used to increase graphic speed
	Dim FFTRealMean As Double			' mean real  FFT value
	Dim FFTRealMin As Double			' mix  real	 FFT value
	Dim FFTImagMax As Double			' max  imag	 FFT value
	Dim FFTImagMean As Double			' mean imag	 FFT value
	Dim FFTImagMin As Double			' min  imag	 FFT value
	Dim FFTAmplMax As Double			' max  ampl	 FFT value
	Dim FFTAmplMean As Double			' mean ampl	 FFT value
	Dim FFTAmplMin As Double			' min  ampl	 FFT value
	Dim FFTPhaseMax As Double			' max  phase FFT value
	Dim FFTPhaseMean As Double		' mean phase FFT value
	Dim FFTPhaseMin As Double			' min  phase FFT value
	
' sine definition variables
	'''Dim SineNbMax As Int						: SineNbMax=10
	'''Dim SineNb As Int								: SineNb=5
	'''Dim SineI As Int								: SineI=0
	''Dim SineOffset As Double				: SineOffset=1
	'''Dim SineDampingCoef As Double		: SineDampingCoef=0.5
	'''Dim SineDamping As Double	
	''''Dim SineW0(SineNbMax) As Double
	'''Dim SineAmpl(SineNbMax) As Double
	'''Dim SinePhase(SineNbMax) As Double
	'''Dim SineNbPeriods(SineNbMax) As Double
	'''SineNbPeriods(0)=20
	'''''SineNbPeriods(1)=45
	'''SineNbPeriods(2)=60
	'''SineNbPeriods(3)=80
	''''SineNbPeriods(4)=100
	''SineNbPeriods(5)=120
	''SineAmpl(0)=1
	'''SineAmpl(1)=.8
	'''SineAmpl(2)=.6
	'''SineAmpl(3)=1
	'''SineAmpl(4)=.5
	''''''SineAmpl(5)=.25
	'''Dim SineModPeriod As Double				: SineModPeriod=5
   '' Dim SineModPercent As Double			:	SineModPercent=.50
	'''Dim SineModW0 As Double

' variables for the drawing areas	
	Dim GraphX1 As Float							: GraphX1=5
	Dim GraphW As Float								: GraphW=256
	Dim GraphW1 As Float							: GraphW1=256
	Dim GraphX2 As Float							: GraphX2=GraphX1+GraphW
	Dim GraphH As Float								: GraphH=105
	Dim GraphY1 As Float							: GraphY1=30
	Dim GraphY2 As Float							: GraphY2=GraphY1+GraphH+30
	Dim ScreenH As Float							: ScreenH=100%y
	Dim ScreenH2 As Float							: ScreenH2=50%y
	Dim CursorX As Float							: CursorX=0
	Dim Vref(2) As Float
	Dim Vals(2,256) As Float
	
	Dim ButtonHeight As Float
	Dim ButtonSpace As Float
	Dim ButtonWidth As Float

' flags for program functions
	Dim flgDisp As String							: flgDisp="DispDraw"
	Dim flgDispList As String					: flgDispList="ListReal"
	Dim flgDispType As String					: flgDispType="DispFFT"
	Dim flgDispFFTType As String			: flgDispFFTType="FftAP"
	Dim flgCalcSines As String				: flgCalcSines="3sin"
	Dim flgDeleteSamples As Boolean		: flgDeleteSamples=False
	Dim flgFFTInverse As Boolean			: flgFFTInverse=False
	Dim flagDot As Boolean						: flagDot=False
	Dim flagCursorMove As Int		
	
' constants for display type
	Dim cDataReal As Int							: cDataReal=0
	Dim cDataimag As Int							: cDataimag=1
	Dim cFFTReal As Int								: cFFTReal=2
	Dim cFFTImag As Int								: cFFTImag=3
	Dim cFFTAmpl As Int								: cFFTAmpl=4
	Dim cFFTPhase As Int							: cFFTPhase=5
	
	Dim HelpIndex As Int							: HelpIndex=0
	Dim HelpIndexMax As Int						: HelpIndexMax=5
	
	Dim CurPos As Int						' cursor screen position
	Dim LineWidth As Int				' line width for drawing
	Dim LineWidth2 As Int				' half line width for drawing
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("FFTdemo")
	Activity.Title="FFTdemo V1.0"
If AStream.IsInitialized = False Then
		AStream.InitializePrefix(Main.serial1.InputStream,True,Main.serial1.OutputStream, "AStream")
	End If
	cvsImage.Initialize(Activity)

	Redim

	InitScale
	
	Timer1.Initialize("Timer1",500)
	
	''InitSinesNb
	InitlsvDisplay
	InitButtonColors
	''InitHelp
	
	'''UpdateSineSetup
	'''UpdateSineParameters
	
	CalcSines(flgCalcSines)
	CalcFFT
	
	DisplayPanelManagement
	Display
End Sub
Sub AStream_NewData (Buffer() As Byte)
Transform=0
For j = 0 To 1 Step 0

 	
		For i = 0 To 256
		SendData=Buffer
		DataReal=conv.DoublesFromBytes(SendData)
		Next
		
	
  Next  
 FuncCalcSines(flgCalcSines)   

	

		
		
	
	
End Sub
Sub AStream_Error
	ToastMessageShow("Connection is broken.", True)
	
End Sub

Sub AStream_Terminated
	AStream_Error
End Sub




Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
If UserClosed Then
		AStream.Close
	End If
End Sub

Sub InitScale
' Initilisation depending on screen resolution

	Dim DeviceLayout As String
	Dim i As Int, y As Float
	
	LineWidth=256/NN				' graph width = 256  if NN < 256 calculation of the LineWidth
	LineWidth2=LineWidth/2	' half line width, used for dispaly
	
	DeviceLayout=GetDeviceLayoutValues
	ScreenH=100%y						' total user screen height
	ScreenH2=50%y						' half user screen height, used to position the graphs
	
' button dimensions calculation
' vertically 6 buttons and 7 spaces
' 1 button space = 1/8 button height = 0.125 * button height
' 6 button heights + 7 button spaces = 6.875 button heights
	i=ScreenH/6.875
	ButtonHeight=i
	i=ScreenH/6.875*.125+.5
	ButtonSpace=i
	ButtonWidth=60dip
	
' graph dimensions
	If DeviceLayout.StartsWith("400") Then			' 400 * 240
		GraphX1=1
		GraphW=256		' 256 time samples
		GraphW1=256
	Else If DeviceLayout.StartsWith("800") Then	' 800 * 480
		GraphX1=3
		GraphW=512
		GraphW1=512
		LineWidth=LineWidth*2
	Else If DeviceLayout.StartsWith("960") Then	' 960 * 640
		GraphX1=4
		GraphW=512
		GraphW1=512
		LineWidth=LineWidth*2
	Else	' DeviceLayout.StartsWith("480") Then	' 480 * 320
		GraphX1=2
		GraphW=256
		GraphW1=256
	End If
	GraphY1=30dip
	GraphH=ScreenH2-GraphY1-4dip
	GraphY2=ScreenH2+GraphY1
	GraphX2=GraphX1+GraphW
	rectDest.Initialize(GraphX1,GraphY1,GraphX2,GraphY1+GraphH)			' used for screen updates
	rectScreen.Initialize(GraphX1,GraphY1,GraphX2,GraphY2+GraphH)
	rectCursor.Initialize(GraphX1,GraphY1,GraphX1+1,GraphY2+GraphH)
	
' positioning of the panels	and buttons
	pnlDrawDisp1.Top=0
	pnlDrawDisp1.Left=GraphX1
	pnlDrawDisp2.Left=GraphX1
	pnlDrawDisp1.Top=3dip
	pnlDrawDisp2.Top=pnlDrawDisp1.Top+ScreenH2
	''pnlSetup.Top=0
	''pnlSetup.Left=0
	''pnlSetup.Height=100%y
	'''pnlSetup.Width=100%x

	pnlToolBox.Left=100%x-ButtonSpace-pnlToolBox.Width
	pnlToolBox.Height=100%y
	pnlDispFunc.Left=pnlToolBox.Left-ButtonSpace-pnlDispFunc.Width
	pnlCursorTools.Left=pnlDispFunc.Left
	pnlFFTType.Left=pnlDispFunc.Left-ButtonSpace-pnlFFTType.Width
	pnlFFTInverse.Left=pnlFFTType.Left
	pnlDisp.Left=pnlDispFunc.Left
	btnHelpOK.Left=100%x-btnHelpOK.Width-ButtonSpace
	
	pnlToolBox.Top=0
	btnCalcSines1.Height=ButtonHeight
	btnCalcSines3.Height=ButtonHeight
	btnCalcCosines3.Height=ButtonHeight
	btnCalcSinesN.Height=ButtonHeight
	btnNSinesSetup.Height=ButtonHeight
	btnHelp.Height=ButtonHeight
	btnCalcSines1.Top=ButtonSpace
	btnCalcSines3.Top=ButtonHeight+2*ButtonSpace
	btnCalcCosines3.Top=2*ButtonHeight+3*ButtonSpace
	btnCalcSinesN.Top=3*ButtonHeight+4*ButtonSpace
	btnNSinesSetup.Top=4*ButtonHeight+5*ButtonSpace
	btnHelp.Top=5*ButtonHeight+6*ButtonSpace
	
	pnlDispFunc.Top=0
	pnlDispFunc.Height=2*ButtonHeight+3*ButtonSpace
	btnDispTime.Height=ButtonHeight
	btnDispFFT.Height=ButtonHeight
	btnDispTime.Top=ButtonSpace
	btnDispFFT.Top=ButtonHeight+2*ButtonSpace
	
	pnlCursorTools.Top=2*ButtonHeight+3*ButtonSpace
	pnlCursorTools.Height=2*ButtonHeight+ButtonSpace
	btnCursorRight.Height=ButtonHeight
	btnCursorLeft.Height=ButtonHeight
	btnCursorLeft.Top=0
	btnCursorRight.Top=ButtonHeight+ButtonSpace
	
	pnlDisp.Top=4*ButtonHeight+5*ButtonSpace
	pnlDisp.Height=2*ButtonHeight+ButtonSpace
	btnDispList.Height=ButtonHeight
	btnDispDraw.Height=ButtonHeight
	btnDispList.Top=0
	btnDispDraw.Top=ButtonHeight+ButtonSpace
	
	pnlFFTInverse.Top=4*ButtonHeight+5*ButtonSpace
	pnlFFTInverse.Height=2*ButtonHeight+ButtonSpace
	btnFFTDelete.Height=ButtonHeight
	btnFFTInverse.Height=ButtonHeight
	btnFFTDelete.Top=0
	btnFFTInverse.Top=ButtonHeight+ButtonSpace

	pnlFFTType.Top=ButtonHeight+2*ButtonSpace
	pnlFFTType.Height=2*ButtonHeight+ButtonSpace
	btnFFTRI.Height=ButtonHeight
	btnFFTAP.Height=ButtonHeight
	btnFFTRI.Top=0
	btnFFTAP.Top=ButtonHeight+ButtonSpace
	
	pnlList.Top=0
	pnlList.Left=0
	pnlList.Width=pnlDispFunc.Left
	pnlDispTools.Top=0
	pnlDispTools.Left=pnlList.Width-pnlDispTools.Width-ButtonSpace
	btnListReal.Height=ButtonHeight
	btnListImag.Height=ButtonHeight
	btnListAmpl.Height=ButtonHeight
	btnListPhase.Height=ButtonHeight
	btnListReal.Top=ButtonSpace
	btnListImag.Top=ButtonHeight+2*ButtonSpace
	btnListAmpl.Top=2*ButtonHeight+3*ButtonSpace
	btnListPhase.Top=3*ButtonHeight+4*ButtonSpace
	lsvDisplay.Height=100%y-lsvDisplay.Top-ButtonSpace
	
	pnlHelp.Top=0
	pnlHelp.Left=0
	pnlHelp.Height=100%y
	pnlHelp.Width=100%x
	btnHelpFirst.Height=ButtonHeight
	btnHelpPrev.Height=ButtonHeight
	btnHelpNext.Height=ButtonHeight
	btnHelpLast.Height=ButtonHeight
	btnHelpOK.Height=ButtonHeight
	btnHelpFirst.Top=ButtonSpace
	btnHelpPrev.Top=ButtonSpace
	btnHelpNext.Top=ButtonSpace
	btnHelpLast.Top=ButtonSpace
	btnHelpOK.Top=ButtonSpace
	
	y=100%y-ButtonSpace-ButtonHeight
	pnlInput.Top=0
	pnlInput.Height=100%y
	pnlInput.Left=0
	pnlInput.Width=100%x
	btnInput0.Height=ButtonHeight
	btnInput1.Height=ButtonHeight
	btnInput2.Height=ButtonHeight
	btnInput3.Height=ButtonHeight
	btnInput4.Height=ButtonHeight
	btnInput5.Height=ButtonHeight
	btnInput6.Height=ButtonHeight
	btnInput7.Height=ButtonHeight
	btnInput8.Height=ButtonHeight
	btnInput9.Height=ButtonHeight
	btnInputDot.Height=ButtonHeight
	btnInputMinus.Height=ButtonHeight
	btnInputBS.Height=ButtonHeight
	btnInputClr.Height=ButtonHeight
	btnInputDel.Height=ButtonHeight
	btnInputStart.Height=ButtonHeight
	btnInputEnd.Height=ButtonHeight
	btnInputLeft.Height=ButtonHeight
	btnInputRight.Height=ButtonHeight
	btnInputCancel.Height=ButtonHeight
	btnInputOK.Height=ButtonHeight

	y=100%y-ButtonSpace-ButtonHeight
	btnInput0.Top=y
	btnInputDot.Top=y
	btnInputMinus.Top=y
	btnInputLeft.Top=y
	btnInputRight.Top=y
	btnInputOK.Top=y

	'''btnNSinesSetupOK.Top=y
	''btnNSinesSetupOK.Height=ButtonHeight
	''btnNSinesSetupOK.Left=100%x-ButtonWidth-ButtonSpace
	
	y=100%y-2*(ButtonSpace+ButtonHeight)
	btnInput1.Top=y
	btnInput2.Top=y
	btnInput3.Top=y
	btnInputStart.Top=y
	btnInputEnd.Top=y
	btnInputCancel.Top=y
	y=100%y-3*(ButtonSpace+ButtonHeight)
	btnInput4.Top=y
	btnInput5.Top=y
	btnInput6.Top=y
	btnInputClr.Top=y
	btnInputDel.Top=y
	y=100%y-4*(ButtonSpace+ButtonHeight)
	btnInput7.Top=y
	btnInput8.Top=y
	btnInput9.Top=y
	btnInputBS.Top=y
	y=(y-txtInputDispCurs.Height-txtInputDisplay.Height)/3
	lblInputTitle.Top=y
	y=2*y+lblInputTitle.Height
	Label1.Top=y
	txtInputDisplay.Top=y
	txtInputDispCurs.Top=y
	btnInputOK.Left=100%x-btnInputOK.Width-ButtonSpace
	btnInputCancel.Left=100%x-btnInputCancel.Width-ButtonSpace

End Sub

Sub Redim
' redim depending on the transformation type
	If Transform=0 Then	
	'''used with  Fft.Transform and Fft.Inverse
	ND2=NN
	End If
	 If Transform=2 Then	
	' used with  Fft.Transform2 and Fft.Inverse2
		ND2=NN/2
	End If
	ND2_1=ND2-1

	Dim FFTReal(ND2) As Double
	Dim FFTImag(ND2) As Double
	Dim FFTAmpl(ND2) As Double
	Dim FFTPhase(ND2) As Double
End Sub

Sub rbtTransform0_Click
' Fft.Transform and Fft.Inverse
Transform=0
Redim
End Sub

Sub rbtTransform2_Click
' Fft.Transform2 and Fft.Inverse2
	Transform=2
	Redim
End Sub


Sub InitlsvDisplay
' initilisation of the ListView for diplaying the values of the samples

	Dim gd As GradientDrawable
	Dim colsDisp(2) As Int
	
	colsDisp(0) = Colors.RGB(255,255,255)
	colsDisp(1) = Colors.RGB(200,200,200)
	gd.Initialize("TOP_BOTTOM",colsDisp)

	lsvDisplay.SingleLineLayout.ItemHeight=25dip
	lsvDisplay.SingleLineLayout.Label.TextColor=Colors.Black
	lsvDisplay.SingleLineLayout.Label.TextSize=14
	lsvDisplay.SingleLineLayout.Background=gd

End Sub

Sub InitButtonColors
' button color initialization

	colsSine1(0) = Colors.RGB(220,10,10)				' red buttons  sines buttons
	colsSine1(1) = Colors.RGB(255,120,120)
	gd1.Initialize("TOP_BOTTOM",colsSine1)
	gd1.CornerRadius=5
	colsSine2(0) = Colors.RGB(252,202,202)
	colsSine2(1) = Colors.RGB(255,128,128)
	gd2.Initialize("TOP_BOTTOM",colsSine2)
	gd2.CornerRadius=5
	
	sdSine1.Initialize
	Dim states(2) As Int
	states(0) = sdSine1.state_enabled
	states(1) = -sdSine1.state_pressed
	sdSine1.addState2(states, gd1)
	Dim states(1) As Int
	states(0) = sdSine1.state_pressed
	sdSine1.addState2(states, gd2)
	
	gd1.Initialize("TOP_BOTTOM",colsSine2)
	gd1.CornerRadius=5
	gd2.Initialize("TOP_BOTTOM",colsSine1)
	gd2.CornerRadius=5
	
	sdSine2.Initialize
	Dim states(2) As Int
	states(0) = sdSine2.state_enabled
	states(1) = -sdSine2.state_pressed
	sdSine2.addState2(states, gd1)
	Dim states(1) As Int
	states(0) = sdSine2.state_pressed
	sdSine2.addState2(states, gd2)
	
	colsList1(0) = Colors.RGB(11,17,183)			' blue buttons   list display
	colsList1(1) = Colors.RGB(117,215,253)
	gd1.Initialize("TOP_BOTTOM",colsList1)
	gd1.CornerRadius=5
	colsList2(0) = Colors.RGB(192,194,248)
	colsList2(1) = Colors.RGB(111,172,234)
	gd2.Initialize("TOP_BOTTOM",colsList2)
	gd2.CornerRadius=5
	
	sdList1.Initialize
	Dim states(2) As Int
	states(0) = sdList1.state_enabled
	states(1) = -sdList1.state_pressed
	sdList1.addState2(states, gd1)
	Dim states(1) As Int
	states(0) = sdList1.state_pressed
	sdList1.addState2(states, gd2)
	
	gd1.Initialize("TOP_BOTTOM",colsList2)
	gd1.CornerRadius=5
	gd2.Initialize("TOP_BOTTOM",colsList1)
	gd2.CornerRadius=5
	
	sdList2.Initialize
	Dim states(2) As Int
	states(0) = sdList2.state_enabled
	states(1) = -sdList2.state_pressed
	sdList2.addState2(states, gd1)
	Dim states(1) As Int
	states(0) = sdList2.state_pressed
	sdList2.addState2(states, gd2)
	
	colsDisp1(0) = Colors.RGB(190,99,1)			' orange buttons    List / Draw  buttons		
	colsDisp1(1) = Colors.RGB(255,222,124)
	gd1.Initialize("TOP_BOTTOM",colsDisp1)
	gd1.CornerRadius=5
	colsDisp2(0) = Colors.RGB(253,242,212)
	colsDisp2(1) = Colors.RGB(238,202,145)
	gd2.Initialize("TOP_BOTTOM",colsDisp2)
	gd2.CornerRadius=5
	
	sdDisp1.Initialize
	Dim states(2) As Int
	states(0) = sdDisp1.state_enabled
	states(1) = -sdDisp1.state_pressed
	sdDisp1.addState2(states, gd1)
	Dim states(1) As Int
	states(0) = sdDisp1.state_pressed
	sdDisp1.addState2(states, gd2)
	
	gd1.Initialize("TOP_BOTTOM",colsDisp2)
	gd1.CornerRadius=5
	gd2.Initialize("TOP_BOTTOM",colsDisp1)
	gd2.CornerRadius=5
	
	sdDisp2.Initialize
	Dim states(2) As Int
	states(0) = sdDisp2.state_enabled
	states(1) = -sdDisp2.state_pressed
	sdDisp2.addState2(states, gd1)
	Dim states(1) As Int
	states(0) = sdDisp2.state_pressed
	sdDisp2.addState2(states, gd2)

	colsTime1(0) = Colors.RGB(3,131,3)				' green buttons   Time / FFT
	colsTime1(1) = Colors.RGB(88,255,65)
	gd1.Initialize("TOP_BOTTOM",colsTime1)
	gd1.CornerRadius=5
	colsTime2(0) = Colors.RGB(189,255,205)
	colsTime2(1) = Colors.RGB(113,255,102)
	gd2.Initialize("TOP_BOTTOM",colsTime2)
	gd2.CornerRadius=5
	
	sdTime1.Initialize
	Dim states(2) As Int
	states(0) = sdTime1.state_enabled
	states(1) = -sdTime1.state_pressed
	sdTime1.addState2(states, gd1)
	Dim states(1) As Int
	states(0) = sdTime1.state_pressed
	sdTime1.addState2(states, gd2)
	
	gd1.Initialize("TOP_BOTTOM",colsTime2)
	gd1.CornerRadius=5
	gd2.Initialize("TOP_BOTTOM",colsTime1)
	gd2.CornerRadius=5
	
	sdTime2.Initialize
	Dim states(2) As Int
	states(0) = sdTime2.state_enabled
	states(1) = -sdTime2.state_pressed
	sdTime2.addState2(states, gd1)
	Dim states(1) As Int
	states(0) = sdTime2.state_pressed
	sdTime2.addState2(states, gd2)
	
	colsFFT1(0) = Colors.RGB(82,7,163)				' violet buttons   FFT type
	colsFFT1(1) = Colors.RGB(223,176,252)
	gd1.Initialize("TOP_BOTTOM",colsFFT1)
	gd1.CornerRadius=5
	colsFFT2(0) = Colors.RGB(234,217,248)
	colsFFT2(1) = Colors.RGB(203,148,252)
	gd2.Initialize("TOP_BOTTOM",colsFFT2)
	gd2.CornerRadius=5
	
	sdFFT1.Initialize
	Dim states(2) As Int
	states(0) = sdFFT1.state_enabled
	states(1) = -sdFFT1.state_pressed
	sdFFT1.addState2(states, gd1)
	Dim states(1) As Int
	states(0) = sdFFT1.state_pressed
	sdFFT1.addState2(states, gd2)
	
	gd1.Initialize("TOP_BOTTOM",colsFFT2)
	gd1.CornerRadius=5
	gd2.Initialize("TOP_BOTTOM",colsFFT1)
	gd2.CornerRadius=5
	
	sdFFT2.Initialize
	Dim states(2) As Int
	states(0) = sdFFT2.state_enabled
	states(1) = -sdFFT2.state_pressed
	sdFFT2.addState2(states, gd1)
	Dim states(1) As Int
	states(0) = sdFFT2.state_pressed
	sdFFT2.addState2(states, gd2)
End Sub

''''Sub InitSinesNb
	'''Dim i As Int
	
	'''spnSinesNb.Clear
	''''spnSinesNb.Prompt="Select the number of sines"
	''''For i=1 To 10
		''spnSinesNb.Add(" 1 sine")
		'''spnSinesNb.Add(" 2 sines")
		''''spnSinesNb.Add(" 3 sines")
		'''spnSinesNb.Add(" 4 sines")
		''''spnSinesNb.Add(" 5 sines")
		'''spnSinesNb.Add(" 6 sines")
		'''spnSinesNb.Add(" 7 sines")
		'''spnSinesNb.Add(" 8 sines")
		'''spnSinesNb.Add(" 9 sines")
		'''spnSinesNb.Add("10 sines")
	'''Next
'''End Sub

Sub btnCalcSines_Click
	Dim Send As View

	Send=Sender
	FuncCalcSines(Send.Tag)
End Sub

Sub FuncCalcSines(ctrl As String)
' sine calculation buttons management

	If flgCalcSines="1sin" Then
		btnCalcSines1.Background = sdSine1
		btnCalcSines1.TextColor=Colors.White
	Else If flgCalcSines="3sin" Then
		btnCalcSines3.Background = sdSine1
		btnCalcSines3.TextColor=Colors.White
	Else If flgCalcSines="3cos" Then
		btnCalcCosines3.Background = sdSine1
		btnCalcCosines3.TextColor=Colors.White
	Else If flgCalcSines="nsin" Then
		btnCalcSinesN.Background = sdSine1
		btnCalcSinesN.TextColor=Colors.White
	End If
	
	flgCalcSines=ctrl

	If flgCalcSines="1sin" Then
		btnCalcSines1.Background = sdSine2
		btnCalcSines1.TextColor=Colors.Black
	Else If flgCalcSines="3sin" Then
		btnCalcSines3.Background = sdSine2
		btnCalcSines3.TextColor=Colors.Black
	Else If flgCalcSines="3cos" Then
		btnCalcCosines3.Background = sdSine2
		btnCalcCosines3.TextColor=Colors.Black
	Else If flgCalcSines="nsin" Then
		btnCalcSinesN.Background = sdSine2
		btnCalcSinesN.TextColor=Colors.Black
	End If
	DoEvents
	
	CalcSines(flgCalcSines)
	CalcFFT
	
	flgFFTInverse=False

	Display
End Sub

Sub btnDispFFTType_Click
	Dim Send As View

	Send=Sender
	DisplayFFTType(Send.Tag)
End Sub

Sub btnList_Click
	Dim Send As View

	Send=Sender
	DisplayList(Send.Tag)
End Sub

Sub btnDispType_Click
	Dim Send As View

	Send=Sender
	DisplayType(Send.Tag)
End Sub

Sub DisplayType(ctrl As String)
	If flgDispType="DispTime" Then
		btnDispTime.Background=sdTime1
		btnDispTime.TextColor=Colors.White
	Else
		btnDispFFT.Background=sdTime1
		btnDispFFT.TextColor=Colors.White
	End If

	flgDispType=ctrl

	If flgDispType="DispTime" Then
		btnDispTime.Background=sdTime2
		btnDispTime.TextColor=Colors.Black
		pnlFFTInverse.Visible=False
		pnlFFTType.Visible=False
	Else
		btnDispFFT.Background=sdTime2
		btnDispFFT.TextColor=Colors.Black
		pnlFFTInverse.Visible=True
		pnlFFTType.Visible=True
	End If
	
	Display

End Sub

Sub btnDisp_Click
	Dim Send As View
	
	If flgDisp="DispList" Then
		btnDispList.Background=sdDisp1
		btnDispList.TextColor=Colors.White
	Else
		btnDispDraw.Background=sdDisp1
		btnDispDraw.TextColor=Colors.White
	End If

	Send=Sender
	flgDisp=Send.Tag
	
	If flgDisp="DispList" Then
		btnDispList.Background=sdDisp2
		btnDispList.TextColor=Colors.Black
		pnlFFTType.Visible=False
		pnlCursorTools.Visible=False
	Else
		btnDispDraw.Background=sdDisp2
		btnDispDraw.TextColor=Colors.Black
		pnlFFTType.Visible=True
		pnlCursorTools.Visible=True
	End If
	DisplayPanelManagement
End Sub




	


Sub DisplayPanelManagement
	If flgDisp="DispList" Then
		pnlList.Visible=True
		pnlDrawDisp1.Visible=False
		pnlDrawDisp2.Visible=False
	Else
		pnlList.Visible=False
		pnlDrawDisp1.Visible=True
		pnlDrawDisp2.Visible=True
	End If
End Sub

Sub DisplayFFTType(Ctrl)
	If flgDispFFTType="FftRI" Then
		btnFFTRI.Background=sdFFT1
		btnFFTRI.TextColor=Colors.White
	Else If flgDispFFTType="FftAP" Then
		btnFFTAP.Background=sdFFT1
		btnFFTAP.TextColor=Colors.White
	End If	
	
	flgDispFFTType=Ctrl

	If flgDispFFTType="FftRI" Then
		btnFFTRI.Background=sdFFT2
		btnFFTRI.TextColor=Colors.Black
	Else If flgDispFFTType="FftAP" Then
		btnFFTAP.Background=sdFFT2
		btnFFTAP.TextColor=Colors.Black
	End If	

	Display
End Sub

Sub CalcSines(SineType As String)
	Dim i As Int,N As Int
	Dim j As Int
	Dim dmp As Double
	Dim w1 As Double, w2 As Double, w3 As Double
	Dim a1 As Double, a2 As Double, a3 As Double
	
	dmp=1/NN/8

	If Transform=0 Then
		N=NN/2
	Else
		N=ND2
	End If
	
	a1=1
	a2=.8
	a3=.5
	w1=cPI/N
	w2=cPI/N*25
	w3=cPI/N*100
	
	DataRealMin=1.0e12
	DataRealMax=-1.0e12
	DataImagMin=1.0e12
	DataImagMax=-1.0e12
	'DataReal=DoublesFromBytes (SendData) 
	For i=0 To NM1
		'''If ckbOffset.Checked=True Then
			'''DataReal(i)=SineOffset
		''Else
			DataReal(i)=0
		'''End If
		If SineType="1sin" Then
			DataReal(i)=DataReal(i)+Sin(w1*i)*a1
		Else If SineType="3sin" Then
			DataReal(i)=DataReal(i)+Sin(w1*i)*a1
			DataReal(i)=DataReal(i)+Sin(w2*i)*a2
			DataReal(i)=DataReal(i)+Sin(w3*i)*a3
		Else If SineType="3cos" Then
			DataReal(i)=DataReal(i)+Cos(w1*i)*a1
			DataReal(i)=DataReal(i)+Cos(w2*i)*a2
			DataReal(i)=DataReal(i)+Cos(w3*i)*a3
		'''Else
			'''For j=0 To SineNb
				'''DataReal(i)=DataReal(i)+Sin(SineW0(j)*i+SinePhase(j))*SineAmpl(j)
			'''Next
		End If
		'''If ckbSineModulation.Checked=True Then
			'''DataReal(i)=DataReal(i)*(1-SineModPercent*(1-Sin(SineModW0*i)))
		'''End If

		''If ckbDamping.Checked=True Then
			'''DataReal(i)=DataReal(i)*Power(cE,-i*SineDamping)
		'''End If
		DataImag(i)=0
		DataRealMin=Min(DataRealMin,DataReal(i))
		DataRealMax=Max(DataRealMax,DataReal(i))
		DataImagMin=Min(DataImagMin,DataImag(i))
		DataImagMax=Max(DataImagMax,DataImag(i))
	Next
	DataRealMean=(DataRealMax+DataRealMin)/2
	DataImagMean=(DataImagMax+DataImagMin)/2

End Sub

Sub CalcFFT
	Dim i As Int

	If Transform=0 Then
		FFTReal=FFT.CopyArray(DataReal)
		FFTImag=FFT.CopyArray(DataImag)
		FFT.Transform(FFTReal,FFTImag)
	Else
		FFT.Transform2(DataReal,FFTReal,FFTImag)
	End If
	
	FFTRealMax=-1.0e12
	FFTRealMin=1.0e12
	FFTImagMax=-1.0e12
	FFTImagMin=1.0e12
	FFTAmplMax=-1.0e12
	FFTAmplMin=1.0e12
	FFTPhaseMax=-1.0e12
	FFTPhaseMin=1.0e12

	For i=0 To ND2_1
		FFTAmpl=FFT.ToAmplitude(FFTReal,FFTImag)
		FFTPhase=FFT.ToPhase(FFTReal,FFTImag)

		FFTRealMin=Min(FFTRealMin,FFTReal(i))
		FFTRealMax=Max(FFTRealMax,FFTReal(i))
		FFTImagMin=Min(FFTImagMin,FFTImag(i))
		FFTImagMax=Max(FFTImagMax,FFTImag(i))
		FFTAmplMin=Min(FFTAmplMin,FFTAmpl(i))
		FFTAmplMax=Max(FFTAmplMax,FFTAmpl(i))
		FFTPhaseMin=Min(FFTPhaseMin,FFTPhase(i))
		FFTPhaseMax=Max(FFTPhaseMax,FFTPhase(i))
	Next
	FFTRealMean=(FFTRealMax+FFTRealMin)/2
	FFTImagMean=(FFTImagMax+FFTImagMin)/2
	FFTAmplMean=(FFTAmplMax+FFTAmplMin)/2
	FFTPhaseMean=(FFTPhaseMax+FFTPhaseMin)/2
End Sub

Sub CalcFFTInverse
	Dim i As Int
	
	If Transform=0 Then
		DataReal=FFT.CopyArray(FFTReal)
		DataImag=FFT.CopyArray(FFTImag)
		FFT.Inverse(DataReal,DataImag)
	Else
		FFT.Inverse2(FFTReal,FFTImag,DataReal)
	End If
	
	DataRealMin=1.0e12
	DataRealMax=-1.0e12
	DataImagMin=1.0e12
	DataImagMax=-1.0e12
	For i=0 To NM1
		DataRealMin=Min(DataRealMin,DataReal(i))
		DataRealMax=Max(DataRealMax,DataReal(i))
		DataImagMin=Min(DataImagMin,DataImag(i))
		DataImagMax=Max(DataImagMax,DataImag(i))
	Next
End Sub

Sub Display
	If flgDispType="DispTime" Then
		btnListAmpl.Visible=False
		btnListPhase.Visible=False
		DisplayList("ListReal")
		DrawGraphic(cDataReal)
		DrawGraphic(cDataimag)
	Else
		btnListAmpl.Visible=True
		btnListPhase.Visible=True
		If flgDispFFTType="FftRI" Then
			DisplayList("ListReal")
			DrawGraphic(cFFTReal)
			DrawGraphic(cFFTImag)
		Else
			DisplayList("ListAmpl")
			DrawGraphic(cFFTAmpl)
			DrawGraphic(cFFTPhase)
		End If
	End If
	CursorX=GraphX1+GraphW1/2
	DrawCursor(0)
	DisplayCursor(CursorX,0)
	Activity.Invalidate2(rectScreen)
End Sub

Sub DisplayList(Ctrl As String)

	If flgDispList="ListReal" Then
		btnListReal.Background = sdList1
		btnListReal.TextColor=Colors.White
	Else If flgDispList="ListImag" Then
		btnListImag.Background = sdList1
		btnListImag.TextColor=Colors.White
	Else If flgDispList="ListAmpl" Then
		btnListAmpl.Background = sdList1
		btnListAmpl.TextColor=Colors.White
	Else If flgDispList="ListPhase" Then
		btnListPhase.Background = sdList1
		btnListPhase.TextColor=Colors.White
	End If

	flgDispList=Ctrl
	If flgDispList="ListReal" Then
		btnListReal.Background = sdList2
		btnListReal.TextColor=Colors.Black
		If flgDispType="DispTime" Then
			If flgFFTInverse=False Then
				FillList(0,NM1,"Time Real")
			Else
				FillList(0,NM1,"Inverse FFT Real")
			End If
		Else
			FillList(2,ND2_1,"FFT Real")
		End If
	Else If flgDispList="ListImag" Then
		btnListImag.Background = sdList2
		btnListImag.TextColor=Colors.Black
		If flgDispType="DispTime" Then
			If flgFFTInverse=False Then
				FillList(1,NM1,"Time Imaginary")
			Else
				FillList(1,NM1,"Inverse FFT Imaginary")
			End If
		Else
			FillList(3,ND2_1,"FFT Imaginary")
		End If
	Else If flgDispList="ListAmpl" Then
		btnListAmpl.Background = sdList2
		btnListAmpl.TextColor=Colors.Black
		FillList(4,ND2_1,"FFT Amplitude")
	Else If flgDispList="ListPhase" Then
		btnListPhase.Background = sdList2
		btnListPhase.TextColor=Colors.Black
		FillList(5,ND2_1,"FFT Phase")
	End If
End Sub

Sub FillList(Mode As Int,Nb As Int,title As String)
	Dim Val As Double, i As Int
	
	lblDisplay.Text=title
	lsvDisplay.Clear

	For i=0 To Nb
		If Mode=cDataReal Then
			Val=DataReal(i)
		Else If Mode=cDataimag Then
			Val=DataImag(i)
		Else If Mode=cFFTReal Then
			Val=FFTReal(i)
		Else If Mode=cFFTImag Then
			Val=FFTImag(i)
		Else If Mode=cFFTAmpl Then
			Val=FFTAmpl(i)
		Else If Mode=cFFTPhase Then
			Val=FFTPhase(i)
		End If
		If ckbRound.Checked=True Then
			Val=Round2(Val,6)
		End If
		lsvDisplay.AddSingleLine(i&" : "&Val)
	Next
End Sub

Sub DrawGraphic(Mode As Int)
	Dim i As Int, j As Int, Scale As Double, N As Int
	Dim x1 As Float,y1 As Float,y2 As Float
	Dim y0, vmax, vmin, vmean As Float
	
	If Mode= cDataReal Then
		vmax=DataRealMax
		vmin=DataRealMin
		vmean=DataRealMean
		y0=GraphY1
		j=0
		If flgFFTInverse=False Then
			lblTitle1.Text="Time  real"
		Else
			lblTitle1.Text="Inverse FFT  real"
		End If
		N=NM1
	Else If Mode=cDataimag Then
		vmax=DataImagMax
		vmin=DataImagMin
		vmean=DataImagMean
		y0=GraphY2
		j=1
		If flgFFTInverse=False Then
			lblTitle2.Text="Time  Imaginary"
		Else
			lblTitle2.Text="Inverse FFT  Imaginary"
		End If
		N=NM1
	Else If Mode=cFFTReal Then
		vmax=FFTRealMax
		vmin=FFTRealMin
		vmean=FFTRealMean
		y0=GraphY1
		j=0
		lblTitle1.Text="FFT  Real"
		N=ND2_1
	Else If Mode=cFFTImag Then
		vmax=FFTImagMax
		vmin=FFTImagMin
		vmean=FFTImagMean
		y0=GraphY2
		j=1
		lblTitle2.Text="FFT  Imaginary"
		N=ND2_1
	Else If Mode=cFFTAmpl Then
		vmax=FFTAmplMax
		vmin=FFTAmplMin
		vmean=FFTAmplMean
		lblTitle1.Text="FFT  Amplitude"
		y0=GraphY1
		j=0
		N=ND2_1
	Else If Mode=cFFTPhase Then
		vmax=FFTPhaseMax
		vmin=FFTPhaseMin
		vmean=FFTPhaseMean
		lblTitle2.Text="FFT  Phase"
		y0=GraphY2
		j=1
		N=ND2_1
	End If
	If Abs(vmax-vmin)>1e-8 Then
		Scale=(GraphH-4)/(vmax-vmin)
		If vmax/vmin<0 OR Abs(vmin)<1e-2 OR Abs(vmax)<1e-2 Then
			vmean=0
		End If
		y1=(vmax-vmean)*Scale+2
	Else
		Scale=(GraphH-4)/2
		y1=GraphH/2
	End If
	y1=y1+y0
	Vref(j)=y1
	GraphW1=N*LineWidth

	rectDest.Top=y0
	rectDest.Bottom=rectDest.Top+GraphH
	rectDest.Right=GraphX2
	
	cvsImage.DrawRect(rectDest,Colors.Black,True,1)
	rectDest.Right=rectDest.Left+(N+1)*LineWidth
	cvsImage.DrawRect(rectDest,Colors.White,True,1)
	cvsImage.DrawLine(GraphX1,y1,GraphX1+N*LineWidth+LineWidth,y1,Colors.Blue,LineWidth)
	For i=0 To N
		x1=GraphX1+i*LineWidth+LineWidth2
		If Mode=cDataReal Then
			y2=y1-DataReal(i)*Scale
		Else If Mode=cDataimag Then
			y2=y1-DataImag(i)*Scale
		Else If Mode=cFFTReal Then
			y2=y1-FFTReal(i)*Scale
		Else If Mode=cFFTImag Then
			y2=y1-FFTImag(i)*Scale
		Else If Mode=cFFTAmpl Then
			y2=y1-FFTAmpl(i)*Scale
		Else If Mode=cFFTPhase Then
			y2=y1-FFTPhase(i)*Scale
		End If
		
		cvsImage.DrawLine(x1,y1,x1,y2,Colors.Blue,LineWidth)
		Vals(j,i)=y2
	Next
End Sub

''''Sub UpdateSineParameters
	'''Dim i As Int, N As Int
	
	'''SineModPeriod=txtModulationPeriod.Text
	'''SineModPercent=txtModulationPercent.Text/100
	'''SineDampingCoef=txtSineDamping.Text
	'''SineDamping=SineDampingCoef*cPI/NN
	'''SineOffset=txtSineOffset.Text
	
	'UpdateOneSineParameters
	
	''''If Transform=0 Then
	''	N=NN/2
	'''Else
		''N=ND2
	''End If

	'''For i=0 To SineNb
		'''SineW0(i)=cPI/N*SineNbPeriods(i)
	'''Next
	'''SineModW0=cPI/N*SineModPeriod
'''End Sub

'''''Sub UpdateOneSineParameters
	'''SineAmpl(SineI)=txtSineAmpl.Text
	''''SinePhase(SineI)=txtSinePhase.Text
	''''SineNbPeriods(SineI)=txtSineNbPeriods.Text
''''End Sub

'''''Sub UpdateSineSetup
	''''Dim i As Int
	
'''	spnSinesNb.SelectedIndex=SineNb
'	If SineNb<>spnSineIndex.Count then
	''	spnSineIndex.Clear
	''	For i=0 To SineNb
	''		spnSineIndex.Add("Sine "&(i+1))
	''	Next
'	End If
	'''''spnSineIndex.SelectedIndex=SineI
	'''''txtModulationPercent.Text=(SineModPercent*100)
	'''''txtModulationPeriod.Text=SineModPeriod
	''''txtSineDamping.Text=SineDampingCoef
	'''txtSineOffset.Text=SineOffset
	'''UpdateOneSineSetup
''''End Sub

'''''Sub UpdateOneSineSetup
	''''txtSineNbPeriods.Text=SineNbPeriods(SineI)
	''''txtSineAmpl.Text=SineAmpl(SineI)
	''''txtSinePhase.Text=(SinePhase(SineI)/RadDeg)
''''End Sub

Sub ckbRound_CheckedChange(Checked As Boolean)
	DisplayList(flgDispList)
End Sub

Sub spnSineIndex_ItemClick (Position As Int, Value As Object)
	SineI=Position
	''UpdateOneSineSetup
End Sub

''''Sub spnSinesNb_ItemClick (Position As Int, Value As Object)
	'''Dim i As Int
	
	'''If Position <> SineNb Then
		'''SineNb=Position
		''''spnSineIndex.Clear
		'''For i=0 To SineNb
			'''spnSineIndex.Add("Sine "&(i+1))
		'''Next
	'''	'''.SelectedIndex=0
	''End If
''End Sub

Sub Activity_Touch (Action As Int, X As Float, Y As Float)
	Dim x1 As Float, i As Int
	
	If X>=GraphX1 AND X<=(GraphX1+GraphW1) AND ((Y>=GraphY1 AND Y<=(GraphY1+GraphH)) OR (Y>=GraphY2 AND Y<=(GraphY2+GraphH))) Then
		If Action=0 OR Action=2 Then
'			x1=Int((X-GraphX1)/LineWidth)*LineWidth+GraphX1+LineWidth2
			i=(X-GraphX1)/LineWidth
			x1=i*LineWidth+GraphX1+LineWidth2
			If x1<>CursorX Then
				DisplayCursor(x1,0)
			End If
		End If
	End If
End Sub

Sub DisplayCursor(X As Float, Mode As Int)
	Dim ind As Int
	Dim Val1, Val2 As Double
	
	If Mode=0 Then
		DrawCursor(1)
		CursorX=X
		ind=(CursorX-GraphX1-LineWidth2)/LineWidth
		If flgDeleteSamples=True Then
			FFTAmpl(ind)=0
			FFTPhase(ind)=0
			FFTReal(ind)=0
			FFTImag(ind)=0
			Vals(0,ind)=Vref(0)
			Vals(1,ind)=Vref(1)
		End If
		DrawCursor(0)
		lblAbscissa1.Text=ind
		lblAbscissa2.Text=ind
		If flgDispType="DispTime" Then
			Val1=DataReal(ind)
			Val2=DataImag(ind)
		Else
			If flgDispFFTType="FftRI" Then
				Val1=FFTReal(ind)
				Val2=FFTImag(ind)
			Else
				Val1=FFTAmpl(ind)
				Val2=FFTPhase(ind)
			End If
		End If
		If ckbRound.Checked=True Then
			Val1=Round2(Val1,6)
			Val2=Round2(Val2,6)
		End If
		lblValue1.Text=Val1
		lblValue2.Text=Val2
	Else
		lblAbscissa1.Text=""
		lblAbscissa2.Text=""
		lblValue1.Text=""
		lblValue2.Text=""
		DrawCursor(1)
	End If
End Sub

Sub DrawCursor(Mode As Int)
	Dim ind As Int
	
	ind=(CursorX-GraphX1-LineWidth2)/LineWidth
	If Mode=0 Then
		cvsImage.DrawLine(CursorX,GraphY1,CursorX,GraphY1+GraphH,Colors.Green,LineWidth)
		cvsImage.DrawLine(CursorX,Vref(0),CursorX,Vals(0,ind),Colors.Red,LineWidth)
		cvsImage.DrawLine(CursorX,GraphY2,CursorX,GraphY2+GraphH,Colors.Green,LineWidth)
		cvsImage.DrawLine(CursorX,Vref(1),CursorX,Vals(1,ind),Colors.Red,LineWidth)
	Else 
		cvsImage.DrawLine(CursorX,GraphY1,CursorX,GraphY1+GraphH,Colors.White,LineWidth)
		cvsImage.DrawLine(CursorX,Vref(0),CursorX,Vals(0,ind),Colors.Blue,LineWidth)
		cvsImage.DrawPoint(CursorX,Vref(0),Colors.Blue)
		cvsImage.DrawLine(CursorX,GraphY2,CursorX,GraphY2+GraphH,Colors.White,LineWidth)
		cvsImage.DrawLine(CursorX,Vref(1),CursorX,Vals(1,ind),Colors.Blue,LineWidth)
		cvsImage.DrawPoint(CursorX,Vref(1),Colors.Blue)
	End If
	rectCursor.Left=CursorX-LineWidth
	rectCursor.Right=CursorX+LineWidth+1
	Activity.Invalidate2(rectCursor)
End Sub

Sub btnCursor_Click
	Dim Vw As View, btn As String
	
	Vw=Sender
	btn=Vw.Tag
	
	If btn="<" Then
		If CursorX>=GraphX1+LineWidth Then
			DisplayCursor(CursorX-LineWidth,0)
		End If
	Else 
		If CursorX<=GraphX1+GraphW1-LineWidth2 Then
			DisplayCursor(CursorX+LineWidth,0)
		End If
	End If
End Sub

Sub btnCursor_LongClick
	Dim Vw As View, btn As String
	Dim x As Float
	
	Vw=Sender
	btn=Vw.Tag
	
	x=10*LineWidth
	If btn="<" Then
		If CursorX>=GraphX1+x Then
			DisplayCursor(CursorX-x,0)
		End If
	Else 
		If CursorX<=GraphX1+GraphW1-x Then
			DisplayCursor(CursorX+x,0)
		End If
	End If
End Sub

Sub btnFFTDelete_Click
	Dim ind As Int
	
	If flgDeleteSamples=False Then
		flgDeleteSamples=True
		btnFFTDelete.Background=sdTime2
		DisplayCursor(CursorX,0)
	Else 
		flgDeleteSamples=False
		btnFFTDelete.Background=sdTime1
	End If
End Sub

Sub btnFFTInverse_Click
	CalcFFTInverse
	DisplayType("DispTime")
	flgFFTInverse=True
	btnFFTDelete_Click
End Sub

''''''Sub txtInput_Click
	'''''Dim Title As String, ret As Int
	
	'''SendView=Sender

	'''If SendView.Tag="SineNbPeriods" Then
	'''	Title="Sinus  "&(SineI+1)&"  nb. of periods"
	''''Else If SendView.Tag="SineAmpl" Then
	'''	Title="Sinus  "&(SineI+1)&"  amplitude"
	'''Else If SendView.Tag="SinePhase" Then
		''Title="Sinus  "&(SineI+1)&"  phase [deg]"
	'''Else If SendView.Tag="ModulationPeriod" Then
	'''	Title="Modulation   nb. of periods"
	'''Else If SendView.Tag="ModulationPercent" Then
	'''	Title="Modulation   percentage"
	'''Else If SendView.Tag="SineOffset" Then
	'''	Title="DC offset"
	''''Else If SendView.Tag="SineDamping" Then
	'''	Title="Damping coefficient"
	'''End If
	
	'''Input(SendView,Title)
'''End Sub

''''Sub Input(ctrl As View,Title As String)
' input panel management
	''''If SendView.Tag="SineAmpl" OR SendView.Tag="SineNbPeriods" OR SendView.Tag="SineDamping" OR SendView.Tag="ModulationPeriod" OR SendView.Tag="ModulationPercent" Then
		''''btnInputMinus.Visible=False
	'''''Else
		'''btnInputMinus.Visible=True
	''End If
	'''lblInputTitle.Text=Title
	'''txtInputDisplay.Text=SendView.Text
	'''txtInputDispCurs.Text=""
	'''''For i=0 To SendView.Text.Length-1
	''''	txtInputDispCurs.Text=txtInputDispCurs.Text&" "
	''''Next
	'''txtInputDispCurs.Text=txtInputDispCurs.Text&"_"
	'''CurPos=i
	
	'''pnlInput.Visible=True
	''''Timer1.Enabled=True
''End Sub

'''Sub btnInputOK_Click
'''	If txtInputDisplay.Text<>"" Then
	'''	SendView.Text=txtInputDisplay.Text
	'''	btnInputMinus.Visible=True
	'''	pnlInput.Visible=False
	''	Timer1.Enabled=False
''	End If
'''End Sub

Sub btnInputCancel_Click
	pnlInput.Visible=False
	Timer1.Enabled=False
	txtInputDispCurs.Visible=True
End Sub

Sub btnInputNb_Click
	Dim Send As View, ch As String
	Dim txt1, txt2 As String
	Dim i As Int
	
	Send=Sender
	ch=Send.Tag
	
	If ch="0" OR ch="1" OR ch="2" OR ch="3" OR ch="4" OR ch="5" OR ch="6" OR ch="7" OR ch="8" OR ch="9" Then
		If CurPos=txtInputDisplay.Text.Length Then
			txtInputDisplay.Text=txtInputDisplay.Text&ch
		Else 
			txt1=txtInputDisplay.Text.SubString2(0,CurPos)
			txt2=txtInputDisplay.Text.SubString2(CurPos,txtInputDisplay.Text.Length)
			txtInputDisplay.Text=txt1&ch&txt2
		End If
		
		If txtInputDispCurs.Text.Length=0 Then
			txtInputDispCurs.Text="_"
		Else
			txtInputDispCurs.Text=" "&txtInputDispCurs.Text
		End If
		CurPos=CurPos+1
	Else If ch="." AND flagDot=False Then	
		flagDot=True
		txtInputDisplay.Text=txtInputDisplay.Text&ch
		txtInputDispCurs.Text=" "&txtInputDispCurs.Text
		CurPos=CurPos+1
	Else If ch="-" Then
		If txtInputDisplay.Text.Length>0 Then
			If txtInputDisplay.Text.CharAt(0)="-" Then
				txtInputDisplay.Text=txtInputDisplay.Text.SubString2(1,txtInputDisplay.Text.Length)
				txtInputDispCurs.Text=txtInputDispCurs.Text.SubString2(1,txtInputDispCurs.Text.Length)
				CurPos=CurPos-1
			Else
				txtInputDisplay.Text=ch&txtInputDisplay.Text
				txtInputDispCurs.Text=" "&txtInputDispCurs.Text
				CurPos=CurPos+1
			End If
		Else
			txtInputDisplay.Text=ch&txtInputDisplay.Text
			txtInputDispCurs.Text=" "&txtInputDispCurs.Text
			CurPos=CurPos+1
		End If
	Else If ch="BS" Then
		If txtInputDisplay.Text.Length>0 Then
			If txtInputDisplay.Text.CharAt(txtInputDisplay.Text.Length-1)="." Then
				flagDot=False
			End If
			txtInputDisplay.Text=txtInputDisplay.Text.SubString2(0,txtInputDisplay.Text.Length-1)
			txtInputDispCurs.Text=txtInputDispCurs.Text.SubString2(1,txtInputDispCurs.Text.Length)
			CurPos=CurPos-1
		Else
			flagDot=False
		End If
	Else If ch="R" Then
		If CurPos<txtInputDisplay.Text.Length Then
			CurPos=CurPos+1
			txtInputDispCurs.Text=" "&txtInputDispCurs.Text
		End If
	Else If ch="L" Then
		If CurPos>0 Then
			CurPos=CurPos-1
			txtInputDispCurs.Text=txtInputDispCurs.Text.SubString2(1,txtInputDispCurs.Text.Length)
		End If
	Else If ch="S" Then
		txtInputDispCurs.Text="_"
		CurPos=0
	Else If ch="E" Then
		For i=CurPos To txtInputDisplay.Text.Length-1
			txtInputDispCurs.Text=" "&txtInputDispCurs.Text
		Next
		CurPos=i
	Else If ch="Clr" Then
		txtInputDisplay.Text=""
		txtInputDispCurs.Text="_"
		CurPos=0
	Else If ch="Del" Then
		If CurPos<txtInputDisplay.Text.Length Then
			txt1=txtInputDisplay.Text.SubString2(0,CurPos)
			txt2=txtInputDisplay.Text.SubString2(CurPos+1,txtInputDisplay.Text.Length)
			txtInputDisplay.Text=txt1&txt2
		End If
	End If
End Sub

Sub Timer1_Tick
	txtInputDispCurs.Visible=Not(txtInputDispCurs.Visible)
End Sub